//http://shop62474960.taobao.com/?spm=a230r.7195193.1997079397.2.9qa3Ky&v=1

#include "IIC.h"
#define delay_count  10
#define delay_count2  100
void delay_1us(u8 x)//ʱ
{
    u8 i=1;
    x=i*x;
    while(x--);
}
////////IICʼ//////////
/*
IICʼ:SCLڸߵƽڼ䣬SDAɸߵƽɵ͵ƽһ½أȻSCL
*/
u8 I2C_Start(void)
{
    SDA_H();
    delay_1us(delay_count);	//ʱ֤ʱƵʵ100KԱӻʶ
    SCL_H();
    delay_1us(delay_count);//ʱ֤ʱƵʵ100KԱӻʶ
    if(!SDA_read()) return 0;//SDAΪ͵ƽæ,˳
    SDA_L();   //SCLڸߵƽʱSDA
    delay_1us(delay_count);
    if(SDA_read()) return 0;//SDAΪߵƽ߳,˳
    SCL_L();
    delay_1us(delay_count);
    return 1;
}
//**************************************
//IICֹͣź
/*
IICֹͣ:SCLڸߵƽڼ䣬SDAɵ͵ƽɸߵƽһ
*/
//**************************************
void I2C_Stop(void)
{
    SDA_L();
    delay_1us(delay_count);
    SCL_L();
    delay_1us(delay_count);
    SCL_H();
    delay_1us(delay_count);
    SDA_H();//SCLڸߵƽڼ䣬SDAɵ͵ƽɸߵƽ             //ʱ
}
//**************************************
//IICӦź
//ڲ:ack (0:ACK 1:NAK)
/*
Ӧ𣺵ӻյݺһ͵ƽź
׼SDAƽ״̬SCLߵƽʱSDA
*/
//**************************************
void I2C_SendACK(u8 i)
{
    if(1==i)
        SDA_H();	             //׼SDAƽ״̬Ӧ
    else
        SDA_L();  						//׼SDAƽ״̬Ӧ
    SCL_H();                    //ʱ
    delay_1us(delay_count);                 //ʱ
    SCL_L() ;                  //ʱ
    delay_1us(delay_count);
}
///////ȴӻӦ////////
/*
()һݺ󣬵ȴӻӦ
ͷSDAôӻʹãȻɼSDA״̬
*/
/////////////////
u8 I2C_WaitAck(void) 	 //Ϊ:=1ACK,=0ACK
{
    uint16_t i=0;
    SDA_H();	        //ͷSDA
    SCL_H();         //SCL߽в
    while(SDA_read())//ȴSDA
    {
        i++;      //ȴ
        if(i==500)//ʱѭ
            break;
    }
    if(SDA_read())//ٴжSDAǷ
    {
        SCL_L();
        return RESET;//ӻӦʧܣ0
    }
    delay_1us(delay_count);//ʱ֤ʱƵʣ
    SCL_L();
    delay_1us(delay_count); //ʱ֤ʱƵʣ
    return SET;//ӻӦɹ1
}


//**************************************
//IIC߷һֽ
/*
һֽ8bit,SCL͵ƽʱ׼SDASCLߵƽʱӻSDA
*/
//**************************************
void I2C_SendByte(u8 dat)
{
    u8 i;
    SCL_L();//SCLͣSDA׼
    for (i=0; i<8; i++)         //8λ
    {
        if(dat&0x80)//SDA׼
            SDA_H();
        else
            SDA_L();
        SCL_H();                //ʱӣӻ

        delay_1us(delay_count);//ʱIICʱƵʣҲǸӻгʱ
        SCL_L();                //ʱӣSDA׼

        delay_1us(delay_count);//ʱIICʱƵ
        dat <<= 1;          //Ƴݵλ
    }
}
//**************************************
//IIC߽һֽ
//**************************************
u8 I2C_RecvByte()
{
    u8 i;
    u8 dat = 0;
    SDA_H();//ͷSDAӻʹ
    delay_1us(1);         //ʱӻ׼SDAʱ
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;

        SCL_H();                //ʱߣӻSDA

        delay_1us(delay_count);
        if(SDA_read()) //
            dat |=0x01;

        SCL_L();           //ʱߣյ

        delay_1us(delay_count);  //ʱӻ׼SDAʱ
    }
    return dat;
}
//**************************************
//http://shop62474960.taobao.com/?spm=a230r.7195193.1997079397.2.9qa3Ky&v=1
//IIC豸дһֽ
//**************************************
u8 Single_WriteI2C_byte(u8 Slave_Address,u8 REG_Address,u8 data)
{
    if(I2C_Start()==0)  //ʼź
    {
        I2C_Stop();
        return RESET;
    }

    I2C_SendByte(Slave_Address);   //豸ַ+дź
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }
     delay_1us(delay_count); 
    I2C_SendByte(REG_Address);    //ڲĴַ
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }

    I2C_SendByte(data);       //ڲĴݣ
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }

    I2C_Stop();   //ֹͣź

    return SET;
}
//**************************************
//http://shop62474960.taobao.com/?spm=a230r.7195193.1997079397.2.9qa3Ky&v=1
//IIC豸ȡһֽ
//**************************************
u8 Single_ReadI2C(u8 Slave_Address,u8 REG_Address,u8 *REG_data,u8 length)
{
    if(I2C_Start()==0)  //ʼź
    {
        I2C_Stop();
        return RESET;
    }

    I2C_SendByte(Slave_Address);    //豸ַ+дź
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }
     delay_1us(delay_count); 
    I2C_SendByte(REG_Address);     //ʹ洢Ԫַ
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }

    if(I2C_Start()==0)  //ʼź
    {
        I2C_Stop();
        return RESET;
    }

    I2C_SendByte(Slave_Address+1);  //豸ַ+ź
    if(!I2C_WaitAck()) {
        I2C_Stop();
        return RESET;
    }
     delay_1us(delay_count2); 
    while(length-1)
    {
        *REG_data++=I2C_RecvByte();       //Ĵ
        I2C_SendACK(0);               //Ӧ

        length--;
    }
    *REG_data=I2C_RecvByte();
    I2C_SendACK(1);     //ֹͣź
    I2C_Stop();                    //ֹͣź
    return SET;
}
