#include "stm32f10x.h"
#include "delay.h"
#include "usart.h"
#include "string.h"
#include "LED.h"
#include "stdio.h"
/*

Keil: MDK5.10.0.2
MCU:stm32f103c8
Ӳӷ
GY-25t---STM32
1GY-25t_RX---STM32_TX
2STM32_TX---FT232,STM32ϴλ
3GY-25t_TX---STM32_RXģ
˵:
óôڷʽȡģݣ9600

עжϺλstm32f10x_it.c
ϵʽ
http://shop62474960.taobao.com/?spm=a230r.7195193.1997079397.2.9qa3Ky&v=1
*/
int fputc(int ch, FILE *f)
{
    while (!(USART1->SR & USART_FLAG_TXE));
    USART_SendData(USART1, (unsigned char) ch);// USART1 Ի USART2 
    return (ch);
}
static void NVIC_Configuration(void)
{
    NVIC_InitTypeDef NVIC_X;

    /* 4ռȼ4Ӧȼ */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    /*ռȼɴжϼ͵ж*/
    /*Ӧȼȼִ*/
    NVIC_X.NVIC_IRQChannel = USART1_IRQn;//ж
    NVIC_X.NVIC_IRQChannelPreemptionPriority = 0;//ռȼ
    NVIC_X.NVIC_IRQChannelSubPriority = 0;//Ӧȼ
    NVIC_X.NVIC_IRQChannelCmd = ENABLE;//ʹжӦ
    NVIC_Init(&NVIC_X);
}
typedef struct
{
    int16_t temp;
    int16_t roll;
    int16_t pitch;
    int16_t yaw;
} gy;
int main(void)
{
    u8 sum=0,i=0;
    int16_t data=0;
    gy my_25t= {0,0,0,0};
    delay_init(72);
    NVIC_Configuration();
    Usart_Int(9600);
    delay_ms(300);//ȴģʼ
    while(1)
    {
        if(Receive_ok)//ڽ
        {

            for(sum=0,i=0; i<(usart_rx_data[3]+4); i++) //rgb_data[3]=3
                sum+=usart_rx_data[i];
            if(sum==usart_rx_data[i])//Уж
            {
                my_25t.roll=(usart_rx_data[4]<<8)|usart_rx_data[5];
                my_25t.pitch=(usart_rx_data[6]<<8)|usart_rx_data[7];
                my_25t.yaw=(usart_rx_data[8]<<8)|usart_rx_data[9];
                my_25t.temp=(usart_rx_data[10]<<8)|usart_rx_data[12];
                printf("roll:%.2f,",(float)my_25t.roll/100.0f);
                printf("pitch:%.2f,",(float)my_25t.pitch/100.0f);
                printf("yaw:%.2f,",(float)my_25t.yaw/100);
                printf("temp:%.2f\r\n ",(float)my_25t.temp/100.0f);
            }
            else
            {
                printf(" sum %d\r\n ",sum);
                printf(" count %d\r\n ",usart_rx_data[3]+4);
            }
            Receive_ok=0;//ϱ־
        }
    }
}
